//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     Red

extern string TimeFrame      = "Current time frame";
extern double Lambda         = 1600;
extern int    MomentumPeriod = 1;

//
//
//
//
//

double hp[];
double momentum[];
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,momentum);
   SetIndexBuffer(1,hp);
      timeFrame = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" HP Filter Velo NORPT V2");
   return(0);
}
int start()
{
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=MathMax(limit-1,0); i>=0; i--)  
   {  
      int y = iBarShift(NULL,timeFrame,Time[i]);
         hp[i] = iCustom(NULL,timeFrame,"HP",Lambda,0,y);
         momentum[i] = hp[i]-iCustom(NULL,timeFrame,"HP",Lambda,0,y+MomentumPeriod);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}